#include "..\script_component.hpp"

/*
 * Function: dragonfly_db_fnc_hashDelete
 * Author: Creedcoder, J.Schmidt
 * Edit: 07.15.2024
 * Copyright © 2024 Creedcoder, J.Schmidt, All rights reserved
 *
 * Do not edit without permission!
 *
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 * To view a copy of this license, vist https://creativecommons.org/licenses/by-nc-sa/4.0/ or send a letter to Creative Commons,
 * PO Box 1866, Mountain View, CA 94042
 *
 * [Description]
 * Delete field in hash stored at key from DB.
 *
 * Arguments:
 * 0: Name of stored field in hash <STRING> (default: "")
 *
 * Return Value:
 * N/A
 *
 * Examples:
 * ["loadout"] call dragonfly_db_fnc_hashDelete (Server or Singleplayer Only)
 * ["loadout"] remoteExecCall ["dragonfly_db_fnc_hashDelete", 2, false] (Multiplayer Only)
 *
 * Public: Yes
 */

params [["_keyField", "", [""]]];

#ifdef __A3__DEBUG__
	diag_log text format ["ArmaDragonflyClient: 'dragonfly_db_fnc_hashDelete' KeyField: '%1'", _keyField];
#endif

if (_keyField == "") exitWith {
    diag_log text format ["ArmaDragonflyClient: 'dragonfly_db_fnc_hashDelete' Invalid Input for KeyField '%1'", _keyField];
};

"ArmaDragonflyClient" callExtension ["hdel", [_keyField]];