# Basic Data Operations

This section contains documentation for the basic data operations of ArmaDragonflyClient that allow for simple key-value storage and retrieval.

## Available Functions

- [delete](delete.md) - Delete a value from the database
- [fetch](fetch.md) - Fetch a value from the database
- [get](get.md) - Get a value from the database
- [save](save.md) - Save the database to disk
- [set](set.md) - Set a value in the database

## Example Usage

```sqf
// Set a value
["myKey", [myValue]] call dragonfly_db_fnc_set;

// Get a value
["myKey", "myFunction"] call dragonfly_db_fnc_get;

// Delete a key
["myKey"] call dragonfly_db_fnc_delete;

// Save database to disk
[] call dragonfly_db_fnc_save;
```

## Related Categories

- [Core Functions](../core/README.md)
- [Hash Operations](../hash/README.md)
- [List Operations](../list/README.md)