---
title: ArmaDragonflyClient - Initialization
icon: mdi:file-text-outline
excerpt: Initial Extension settings.
---

# dragonfly_db_fnc_init

## Description
Initializes the ArmaDragonflyClient extension and sets up the initial settings. This function loads the extension, checks its version, sets the buffer size, and logs the initialization status. It is automatically called during mission startup.

## Syntax
```sqf
// This function is automatically called during initialization and doesn't need to be called directly
```

## Parameters
None. This function does not require any parameters.

## Return Value
None. The function sets up internal variables and logs initialization information.

## Examples
This function is automatically executed during framework initialization and doesn't need to be called manually.

## Notes
- Sets the global buffer size to 10240 bytes (10KB)
- Logs the DLL version number for reference
- Confirms successful loading of all functions
- Outputs initialization status to the RPT logs
- This is one of the first functions called when the framework loads

## Related Functions
- `dragonfly_db_fnc_save`: Saves database data to disk

## Links

[Add Task](addTask.md) |
[Handler](handler.md) |
[Init](init.md) |
[Print Addon Name](printAddonName.md) |
[Process Queue](processQueue.md) |
[Scheduler](scheduler.md) |
[Test](test.md)