# List Operations

This section contains documentation for the list operations of ArmaDragonflyClient that allow for working with ordered collections of items.

## Available Functions

- [listAdd](listAdd.md) - Add an item to a list
- [listGet](listGet.md) - Get items from a list
- [listLoad](listLoad.md) - Load a list from the database
- [listRemove](listRemove.md) - Remove an item from a list
- [listSet](listSet.md) - Set an item in a list

## Example Usage

```sqf
// Add an item to a list
["myList", ["myItem"]] call dragonfly_db_fnc_listAdd;

// Set an item at a specific index
["myList", 0, [myNewValue]] call dragonfly_db_fnc_listSet;

// Get an item at a specific index
["myList", 0, "myFunction"] call dragonfly_db_fnc_listGet;

// Load all items from a list
["myList", "myFunction"] call dragonfly_db_fnc_listLoad;

// Remove an item at a specific index
["myList", 0] call dragonfly_db_fnc_listRemove;
```

## Related Categories

- [Core Functions](../core/README.md)
- [Basic Data Operations](../basic/README.md)
- [Hash Operations](../hash/README.md)